#ident "%W%"
/*
 * tst_test.c - simple test/example of the tst code
 * Copyright (C) 2000 Rex Feany <laeos@laeos.net>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_STDIO_H
# include <stdio.h>
#endif

#include <stddef.h>

#include "xp_tst.h"


struct spork {
	int num;
	char *name;
	char *data;
};

struct spork list[] = {
	{ 1, "fbo", "fbo-data" },
	{ 2, "foa", "foa-data" },
	{ 3, "Fef", "i should find this" },
	{ 4, "feo", "feo-data" },
	{ 5, "eeo", "eeo-data" },
	{ 6, "coo", "coo-data" },
	{ 7, "boo", "boo-data" },
	{ 99, "foabaz", "haha work" },
	{ 8, "aoo", "aoo-data" },
};

int main () {

	XP_TST_HEAD foo;
	XP_TST_ARRAY *f;

	xp_tst_init(&foo);

	xp_tst_build(&foo, list, sizeof(struct spork), offsetof(struct spork, name), sizeof(list)/sizeof(struct spork));

	xp_tst_insert(&foo, "ao1", "key-ao1");
	xp_tst_insert(&foo, "bo2", "key-bo2");
	xp_tst_insert(&foo, "ahro3", "key-ahro3");
	xp_tst_insert(&foo, "bo4", "key-bo4");

	f = xp_tst_partial(&foo, "fo", 0, 0);

	if ( f == NULL ) {
		printf("no matches\n");
		return 0;
	}

	while (f->data) {
		printf("i got %s\n", ((struct spork *)f->data)->data );
		++f;
	}

	return 0;
}

